/*
 * EndFrame.java
 *
 * Created on 26. Februar 2008, 14:14
 */



package de.elrador.treibjagd.client.view.end;



import de.elrador.treibjagd.common.game.Player;

import java.util.Collections;
import java.util.List;


/**
 *
 * @author  Jacob
 */
public class EndFrame extends javax.swing.JFrame {
    Player[] sortedPlayers;
    byte rank;
    /** Creates new form EndFrame */
    public EndFrame(Player[] players, Player localPlayer) {
	    List<Player> playerList = java.util.Arrays.asList(players);
	    Collections.sort(playerList);
	    Collections.reverse(playerList);
	    sortedPlayers = new Player[players.length];
	    playerList.toArray(sortedPlayers);

	    for(byte i=0; i<sortedPlayers.length; i++) {
		    if(players[i].id() == localPlayer.id()) rank = (byte)(i+1);
	    }
	    initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
        // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
        private void initComponents() {
                youareLabel = new javax.swing.JLabel();
                playerpositionLabel = new javax.swing.JLabel();
                gameoverLabel = new javax.swing.JLabel();
                no1Label = new javax.swing.JLabel();
                no2Label = new javax.swing.JLabel();
                no3Label = new javax.swing.JLabel();
                no4Label = new javax.swing.JLabel();
                no5Label = new javax.swing.JLabel();
                no6Label = new javax.swing.JLabel();
                player1Label = new javax.swing.JLabel();
                player2Label = new javax.swing.JLabel();
                player3Label = new javax.swing.JLabel();
                player4Label = new javax.swing.JLabel();
                player5Label = new javax.swing.JLabel();
                player6Label = new javax.swing.JLabel();
                newgameButton = new javax.swing.JButton();
                exitButton = new javax.swing.JButton();
                race1Label = new javax.swing.JLabel();
                race2Label = new javax.swing.JLabel();
                race3Label = new javax.swing.JLabel();
                race4Label = new javax.swing.JLabel();
                race5Label = new javax.swing.JLabel();
                race6Label = new javax.swing.JLabel();
                points1Label = new javax.swing.JLabel();
                points2Label = new javax.swing.JLabel();
                points3Label = new javax.swing.JLabel();
                points4Label = new javax.swing.JLabel();
                points5Label = new javax.swing.JLabel();
                points6Label = new javax.swing.JLabel();

                setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
                youareLabel.setText("Du wurdest");

                playerpositionLabel.setForeground(new java.awt.Color(255, 0, 0));
                playerpositionLabel.setText(""+rank+".!");

                gameoverLabel.setFont(new java.awt.Font("Tahoma", 0, 14));
                gameoverLabel.setText("Spielende");

                no1Label.setText("1.");

                no2Label.setText("2.");

                no3Label.setText("3.");

                no4Label.setText("4.");

                no5Label.setText("5.");

                no6Label.setText("6.");

                player1Label.setText(sortedPlayers.length >= 1 ? sortedPlayers[0].name() : "");

                player2Label.setText(sortedPlayers.length >= 2 ? sortedPlayers[1].name() : "");

                player3Label.setText(sortedPlayers.length >= 3 ? sortedPlayers[2].name() : "");

                player4Label.setText(sortedPlayers.length >= 4 ? sortedPlayers[3].name() : "");

                player5Label.setText(sortedPlayers.length >= 5 ? sortedPlayers[4].name() : "");

                player6Label.setText(sortedPlayers.length >= 6 ? sortedPlayers[5].name() : "");

                newgameButton.setText("Neues Spiel");

                exitButton.setText("Beenden");
                exitButton.addActionListener(new java.awt.event.ActionListener() {
                        public void actionPerformed(java.awt.event.ActionEvent evt) {
                                quitButtonPerformed(evt);
                        }
                });

                race1Label.setText(sortedPlayers[0].race().name());

                race2Label.setText(sortedPlayers.length >= 2 ? sortedPlayers[1].race().name() : "");

                race3Label.setText(sortedPlayers.length >= 3 ? sortedPlayers[2].race().name() : "");

                race4Label.setText(sortedPlayers.length >= 4 ? sortedPlayers[3].race().name() : "");

                race5Label.setText(sortedPlayers.length >= 5 ? sortedPlayers[4].race().name() : "");

                race6Label.setText(sortedPlayers.length >= 6 ? sortedPlayers[5].race().name() : "");

                points1Label.setText(""+sortedPlayers[0].score());

                points2Label.setText(sortedPlayers.length >= 2 ? ""+sortedPlayers[1].score() : "");

                points3Label.setText(sortedPlayers.length >= 3 ? ""+sortedPlayers[2].score() : "");

                points4Label.setText(sortedPlayers.length >= 4 ? ""+sortedPlayers[3].score() : "");

                points5Label.setText(sortedPlayers.length >= 5 ? ""+sortedPlayers[4].score() : "");

                points6Label.setText(sortedPlayers.length >= 6 ? ""+sortedPlayers[5].score() : "");

                javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
                getContentPane().setLayout(layout);
                layout.setHorizontalGroup(
                        layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addGroup(layout.createSequentialGroup()
                                                .addContainerGap()
                                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                                                .addGroup(layout.createSequentialGroup()
                                                                        .addComponent(newgameButton)
                                                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED))
                                                                .addComponent(youareLabel))
                                                        .addGroup(layout.createSequentialGroup()
                                                                .addComponent(no1Label)
                                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                                .addComponent(player1Label))
                                                        .addGroup(layout.createSequentialGroup()
                                                                .addComponent(no2Label)
                                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                                .addComponent(player2Label))
                                                        .addGroup(layout.createSequentialGroup()
                                                                .addComponent(no3Label)
                                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                                .addComponent(player3Label))
                                                        .addGroup(layout.createSequentialGroup()
                                                                .addComponent(no4Label)
                                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                                .addComponent(player4Label))
                                                        .addGroup(layout.createSequentialGroup()
                                                                .addComponent(no5Label)
                                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                                .addComponent(player5Label))
                                                        .addGroup(layout.createSequentialGroup()
                                                                .addComponent(no6Label)
                                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                                .addComponent(player6Label)))
                                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                        .addGroup(layout.createSequentialGroup()
                                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                                .addComponent(playerpositionLabel))
                                                        .addComponent(exitButton)
                                                        .addGroup(layout.createSequentialGroup()
                                                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                                        .addComponent(race4Label)
                                                                        .addComponent(race1Label)
                                                                        .addComponent(race2Label)
                                                                        .addComponent(race3Label)
                                                                        .addComponent(race5Label)
                                                                        .addComponent(race6Label))
                                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                                        .addComponent(points4Label)
                                                                        .addGroup(layout.createSequentialGroup()
                                                                                .addGap(2, 2, 2)
                                                                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                                                        .addComponent(points3Label)
                                                                                        .addComponent(points2Label)
                                                                                        .addComponent(points1Label)))
                                                                        .addGroup(layout.createSequentialGroup()
                                                                                .addGap(2, 2, 2)
                                                                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                                                        .addComponent(points6Label)
                                                                                        .addComponent(points5Label)))))))
                                        .addGroup(layout.createSequentialGroup()
                                                .addGap(72, 72, 72)
                                                .addComponent(gameoverLabel)))
                                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                );
                layout.setVerticalGroup(
                        layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(layout.createSequentialGroup()
                                .addGap(17, 17, 17)
                                .addComponent(gameoverLabel)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                        .addComponent(youareLabel)
                                        .addComponent(playerpositionLabel))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addGroup(layout.createSequentialGroup()
                                                .addComponent(race1Label)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(race2Label)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(race3Label)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(race4Label)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(race5Label)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(race6Label))
                                        .addGroup(layout.createSequentialGroup()
                                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                                        .addComponent(no1Label)
                                                        .addComponent(player1Label))
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                                        .addComponent(no2Label)
                                                        .addComponent(player2Label))
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                                        .addComponent(no3Label)
                                                        .addComponent(player3Label))
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                                        .addComponent(no4Label)
                                                        .addComponent(player4Label))
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                                        .addComponent(no5Label)
                                                        .addComponent(player5Label))
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                                        .addComponent(no6Label)
                                                        .addComponent(player6Label)))
                                        .addGroup(layout.createSequentialGroup()
                                                .addComponent(points1Label)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(points2Label)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(points3Label)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(points4Label)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(points5Label)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(points6Label)))
                                .addGap(29, 29, 29)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                        .addComponent(newgameButton)
                                        .addComponent(exitButton))
                                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                );
                pack();
        }// </editor-fold>//GEN-END:initComponents

	private void quitButtonPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_quitButtonPerformed
		System.exit(0);
	}//GEN-LAST:event_quitButtonPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /*java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new EndFrame().setVisible(true);
            }
        });*/
    }
    
        // Variables declaration - do not modify//GEN-BEGIN:variables
        private javax.swing.JButton exitButton;
        private javax.swing.JLabel gameoverLabel;
        private javax.swing.JButton newgameButton;
        private javax.swing.JLabel no1Label;
        private javax.swing.JLabel no2Label;
        private javax.swing.JLabel no3Label;
        private javax.swing.JLabel no4Label;
        private javax.swing.JLabel no5Label;
        private javax.swing.JLabel no6Label;
        private javax.swing.JLabel player1Label;
        private javax.swing.JLabel player2Label;
        private javax.swing.JLabel player3Label;
        private javax.swing.JLabel player4Label;
        private javax.swing.JLabel player5Label;
        private javax.swing.JLabel player6Label;
        private javax.swing.JLabel playerpositionLabel;
        private javax.swing.JLabel points1Label;
        private javax.swing.JLabel points2Label;
        private javax.swing.JLabel points3Label;
        private javax.swing.JLabel points4Label;
        private javax.swing.JLabel points5Label;
        private javax.swing.JLabel points6Label;
        private javax.swing.JLabel race1Label;
        private javax.swing.JLabel race2Label;
        private javax.swing.JLabel race3Label;
        private javax.swing.JLabel race4Label;
        private javax.swing.JLabel race5Label;
        private javax.swing.JLabel race6Label;
        private javax.swing.JLabel youareLabel;
        // End of variables declaration//GEN-END:variables
    
}
